unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics,
  Windows, Dialogs, StdCtrls, Messages;

const
  PIPE_NAME = '\\.\pipe\MDB';
  PIPE_ACCESS_DUPLEX = 3;
  PIPE_TYPE_MESSAGE = 4;
  PIPE_READMODE_MESSAGE = 2;
  PIPE_WAIT = 0;
  PIPE_TIMEOUT = 0;
  MaxConnections=10;
  BufMax=100;

type
  TBuffer=array[1..BufMax] of byte;


  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    BuTest: TButton;
    Edit1: TEdit;
    ListBox1: TListBox;
    procedure BuTestClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;


  TPipeThread = class(TThread)
  private
    hPipe: THandle;
  protected
    procedure execute; override;
  public
    Buffer: TBuffer;
    procedure CreatePipe;
    procedure WaitForClientConnection;
    Procedure Debug(Const s: string);
    procedure Fehler(const s: string);
  end;

var
  Form1: TForm1;
  PT: TPipeThread;

implementation

uses
  LazLogger;

{$R *.lfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  PT:=TPipeThread.create(false, 500000);
end;

procedure TForm1.BuTestClick(Sender: TObject);
begin
  ListBox1.AddItem('Test',nil);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Debugln('FormCreate');
end;

procedure TPipeThread.Debug(const s: string);
begin
  Debugln(s);
end;

procedure TPipeThread.Fehler(const s: string);
begin
  Debugln('Fehler: ', s);
  halt;
end;

procedure TPipeThread.execute;
begin
    CreatePipe;
    Debug('Warte auf Client');
    WaitForClientConnection;
    Debug('Client verbunden, Thread wird beendet');
    Terminate;
end;

procedure TPipeThread.CreatePipe;
begin
  Debug('Erstelle Pipe ' + PIPE_NAME);
  hPipe := CreateNamedPipe(PIPE_NAME, PIPE_ACCESS_DUPLEX,
                           PIPE_TYPE_MESSAGE or PIPE_READMODE_MESSAGE or PIPE_WAIT,
                           MaxConnections, BufMax, BufMax, PIPE_TIMEOUT, nil);
  if hPipe = INVALID_HANDLE_VALUE
  then Fehler('Erstellen der Pipe fehlgeschlagen');
  Debug('Pipe erfolgreich erstellt.');

end;

procedure TPipeThread.WaitForClientConnection;
begin
  if not ConnectNamedPipe(hPipe, nil)
  then Fehler('beim Verbinden');
  Debug('Mit Client verbunden');
end;


end.

